<?php
require_once('../config/MysqliDb.php');

class Items{   
    
    private $itemsTable = "shedhub_ids";      
    public $id;
    public $name;
    public $description;
    public $price;
    public $category_id;   
    public $created; 
	public $modified; 
    private $conn;
		
	function claim(){
	    global $db;
	    
	    //check if token exists if not return error message
	    $db->where ("api_key", $this->token);
        $tokenExist = $db->getOne ("shedhub_api_users"); 
	    
	    if($tokenExist){
	        if($tokenExist['permission_to_claim_ids'] == 1){
	            $data = Array (
                	'claimed_by_user_name' => $this->name,
                	'claimed_date_time' => $this->created,
                );
                
                $db->where ('shedhub_id', $this->id);
                if ($db->update ('shedhub_ids', $data))
                    return json_encode(array("message" => "SHIN: Claimed."));
                else
                    return json_encode(array("message" => "SHIN: Unable to claim shin."));
	        }else{
	            return json_encode(array("message" => "SHIN: Token can't claim shin."));
	        }
	    }else{
	         return json_encode(array("message" => "SHIN: Not a valid token."));
	    }
	    
	}
	
	function assign(){
	    global $db;
	    
	    //check if token exists if not return error message
	    $db->where ("api_key", $this->token);
        $tokenExist = $db->getOne ("shedhub_api_users"); 
        
        if($tokenExist){
            if($tokenExist['permission_to_assign_to_brand'] == 1){
                $data = Array (
            	'assigned_to_brand' => 1,
            	'assigned_brand_id' => $this->brand_id,
            	'assigned_brand_real_name_at_time_of_assignment' => $this->name,
            	'date_time_assigned_to_brand' => $this->created,
                );
                
                $db->where ('shedhub_id', $this->id);
                if ($db->update ('shedhub_ids', $data))
                    return json_encode(array("message" => "SHIN: Brand Assigned."));
                else
                    return json_encode(array("message" => "SHIN: Unable to assign a brand."));
            }else{
                return json_encode(array("message" => "SHIN: Token can't assign to brand."));
            }
            
        }else{
            return json_encode(array("message" => "SHIN: Not a valid token."));
        }
    }
    
    function tag(){
        global $db;
        
        //check if token exists if not return error message
	    $db->where ("api_key", $this->token);
        $tokenExist = $db->getOne ("shedhub_api_users"); 
        
        //make sure to do select first before inserting, get the latest data
        $db->where ("shedhub_id", $this->id);
        $db->orderBy("dbid","desc");
        $isExisting = $db->getOne ("shedhub_id_shed_description_associations"); 
        
        if($tokenExist){
            
            $data = Array (
            	'shedhub_id' => $items->id,
            	'date_description_updated' => $this->created,
            	'shed_description_updated_by_username' => $this->name,
            	'manufacturer_real_name' => $this->manufacturer_name,
            	'manufacturer_username' => $this->manufacturer_username_name,
            	'width' => $this->width,
            	'length' => $this->length,
            	'height' => $this->height,
            	'manufacturer_building_frame_style' => $this->manufacturer_frame_style,
            	'standardized_building_frame_style' => $this->standard_frame_style,
            	'siding_material_1' => $this->sliding_material_1,
            	'siding_material_2' => $this->sliding_material_2,
            	'siding_color' => $this->sliding_color,
            	'roof_color' => $this->roof_color,
            	'roof_material' => $this->roof_material,
            	'trim_color' => $this->trim_color,
            	'door_color' => $this->door_color,
            	'primary_photo_url' => $this->photo_url,
            	'url_to_view_shed_description' => $this->shed_description_url,
            	'shed_description_unstructured_text_string' => $this->shed_description_text,
            	'manufacturer_id_number' => $this->manufacturer_id,
            );
            
            if($isExisting){
                //get all values from old latest, add new row
                unset($isExisting['dbid']);
                unset($isExisting['date_description_updated']);
                $isExisting['date_description_updated'] = $this->created;
                $cleaned_data = array_filter($data);
                $data = array_unique(array_merge($isExisting,$cleaned_data));
            }
            
            $id = $db->insert ('shedhub_id_shed_description_associations', $data);
            
            if ($id){
               return true;
            }else{
              return false;
            }
            
        }else{
            return json_encode(array("message" => "SHIN: Not a valid token."));
        }
    }
}
?>